// main.js

var path = require('path');
var fs = require('fs');

function onBeforeBuildFinish (options, callback) {
    Editor.log('Building ' + options.platform + ' to ' + options.dest); // 你可以在控制台输出点什么

    Editor.log(JSON.stringify(options));
    // var mainJsPath = path.join(options.dest, 'src/project.js');  // 获取发布目录下的 main.js 所在路径
    // var script = fs.readFileSync(mainJsPath, 'utf8');     // 读取构建好的 main.js
    // // script += '\n' + 'window.myID = "01234567";';         // 添加一点脚本到
    // fs.writeFileSync(mainJsPath + "s", script);                 // 保存 main.js


    callback();
}

function listJS(dir, _files) {
    var files = fs.readdirSync(dir);

    for(var f of files)
    {
        var fp = path.join(dir , f);

        var fst = fs.statSync(fp);


        if(fst.isDirectory())
        {
            listJS(fp, _files);
        }else {

            if(fst.isFile() && f.toLowerCase().endsWith(".js")) {

                Editor.log(fp);
                _files.push(fp);
            }
        }
    }
}

function removeLog(file) {
    var script = fs.readFileSync(file, 'utf8');     // 读取构建好的 main.js
    var script_old = script;

    script = script.replace(/^\s*cc\s*\.\s*log\s*\(/gm, ' 0xabcdef||cc.log(');
    script = script.replace(/\)\s*cc\s*\.\s*log\s*\(/gm, ') 0xabcdef||cc.log(');

    script = script.replace(/^\s*console\s*\.\s*log\s*\(/gm, ' 0xabcdef||console.log(');
    script = script.replace(/\)\s*console\s*\.\s*log\s*\(/gm, ') 0xabcdef||console.log(');

    if(script !== script_old)
    {
        Editor.log('removeLog: ' + file);
        fs.writeFileSync(file, script);
    }else{
        Editor.log('noLog: ' + file);
    }


}

function revertLog(file) {
    var script = fs.readFileSync(file, 'utf8');     // 读取构建好的 main.js
    var script_old = script;

    script = script.replace(/0xabcdef\|\|cc\.log\(/gm, ' cc.log(');
    script = script.replace(/0xabcdef\|\|console\.log\(/gm, ' console.log(');


    if(script !== script_old)
    {
        Editor.log('revertLog: ' + file);
        fs.writeFileSync(file, script);
    }else{
        Editor.log('noLog: ' + file);
    }
}

function onBuildStart (options, callback) {

    Editor.log('Building Start: ' + options.platform + ' debug ' + options.debug); // 你可以在控制台输出点什么


    var projdir = options.project;

    var files = [];
    listJS(projdir + '/library', files);


    if(options.debug)
    {
        for (var f of files) {
            revertLog(f)
        }
    }else {
        for (var f of files) {
            removeLog(f)
        }
    }
    callback();
}

function onBuildFinish (options, callback) {
    Editor.log('Building Finish: ' + options.platform + ' to ' + options.dest);

    var projdir = options.project;

    var files = [];
    listJS(projdir + '/library', files);

    for(var f of files)
    {
        revertLog(f)
    }

    callback();
}

module.exports = {
    load () {
        // Editor.Builder.on('before-change-files', onBeforeBuildFinish);
        Editor.Builder.on('build-start', onBuildStart);
        // Editor.Builder.on('build-finished', onBuildFinish);
    },

    unload () {
        // Editor.Builder.removeListener('before-change-files', onBeforeBuildFinish);
        Editor.Builder.removeListener('build-start', onBuildStart);
        // Editor.Builder.removeListener('build-finished', onBuildFinish);
    }
};